routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CheckOutController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\HistoryController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\TransactionController;
use App\Http\Controllers\TransactionsController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/home', function () {
    return view('home');
})->middleware('auth')->name('home');

Route::get('/', [CustomerController::class, 'index'])->name('customer');
Route::get('list-product/{product}', [CustomerController::class, 'listProduct'])->name('listproduct.show');
Route::get('list-detail-product/{product}/{category}', [CustomerController::class, 'listDetailProduct'])->name('listdetailproduct.show');
Route::get('login', [AuthController::class, 'login'])->name('login');
Route::post('login', [AuthController::class, 'logon'])->name('logon');
Route::get('logout', [AuthController::class, 'logout'])->name('logout');
Route::get('register', [UserController::class, 'register'])->name('register');
Route::get('forgot-password', [AuthController::class, 'forgotPassword'])->name('forgot.Password');
Route::get('email', [AuthController::class, 'checkMail'])->name('checkMail');
Route::put('Change-password', [AuthController::class, 'changePassword'])->name('change.Password');

Route::group(['prefix' => 'user', 'middleware' => ['auth', 'role:'.role_user]], function () {
    Route::get('/', [HomeController::class, 'index']);
    Route::get('cart', [CartController::class, 'index'])->name('cart.index');
    Route::post('cart-store', [CartController::class, 'addcart'])->name('cart.store');
    Route::delete('cart-delete/{cart}', [CartController::class, 'destroy'])->name('cart.delete');
    Route::get('history', [HistoryController::class, 'index'])->name('history.index');
    Route::post('checkout', [CheckOutController::class, 'payment'])->name('payment');
    Route::get('payment', [CheckOutController::class, 'returnPayment'])->name('return.payment');
    Route::get('history/{history}', [HistoryController::class, 'detail'])->name('history.detail');
    Route::resource('transactions', TransactionController::class);
});

Route::group(['prefix' => 'admin', 'middleware' => ['auth', 'role:'.role_admin]], function () {

    Route::get('add-user', [UserController::class, 'addUser'])->name('add.user');
    Route::get('restore/{restore}', [CategoryController::class, 'restore'])->name('category.restore');
    Route::resource('categories', CategoryController::class);
    Route::get('listSoftDelete', [CategoryController::class, 'listSoftDelete'])->name('list.categorysoftDelete');
    Route::delete('realdelete/{realdelete}', [CategoryController::class, 'realDelete'])->name('category.realDelete');
    Route::resource('users', UserController::class);
});
Route::group(['prefix' => 'shop', 'middleware' => ['auth', 'role:'.role_shop]], function () {
    Route::get('productSoftDelete', [ProductController::class, 'listSoftDelete'])->name('product.softDelete');
    Route::get('restore/{restore}', [ProductController::class, 'restore'])->name('product.restore');
    Route::delete('realdelete/{realdelete}', [ProductController::class, 'realDelete'])->name('product.realDelete');
    Route::get('order', [OrderController::class, 'index'])->name('order.index');
    Route::put('order/{order}', [OrderController::class, 'update'])->name('order.update');
    Route::post('product-discount', [ProductController::class, 'updateDiscount'])->name('product.updateDiscount');
    Route::resource('products', ProductController::class);
});
Route::resource('users', UserController::class)->only('store');

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use PhpParser\Node\Stmt\Static_;

class Product extends Model
{
    
    use HasFactory,SoftDeletes;
    const PAGIANION=10;
    protected $fillable=[
        'user_shop_id',
        'category_id',
        'name',
        'price',
        'discount',
        'image',
        'create',

    ];
    public function user(){
        return $this->belongsTo(User::class,'user_shop_id','id');
    }
    public function category(){
        return $this->belongsTo(Category::class,'category_id','id');
    }
    public function images(){
        return $this->hasMany(Image::class,'product_id','id');
    }
    public function carts(){
        return $this->hasMany(Cart::class,'product_id','id');
    }
    public function histories(){
        return $this->hasMany(History::class,'product_id','id');
    }
    public function whereProduct($id){   
        return $this->where('id',$id);
    }
    public function whereCategoryProduct($id){
        return $this->where('category_id','=',$id);
    }
    public function whereUserProduct($id){
        return $this->where('user_shop_id','=',$id);
    }
    public function scopeSearch($query){
        if($key=request()->key){
            $key=request()->key;
            $query=$query->where('name','LIKE','%'.$key.'%');
        }
        return $query;
    }
    
    public function productOrderBy(){
          return $this->take(5)->orderBy('discount','DESC')->get();
       
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ProductRequest;
use App\Models\Category;
use App\Models\Image;
use App\Models\Product;
use App\Models\User;
use Illuminate\Http\Request;

class ProductController extends Controller
{

    private $product;
    private $category;
    private $image;
    public function __construct(Product $product, Category $category, Image $image)
    {
        $this->image = $image;
        $this->product = $product;
        $this->category = $category;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = $this->product->whereUserProduct(auth()->user()->id)->with('category')->get();
        return view('products.index')->with('products', $products);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = $this->category->all();
        $user = auth()->user()->id;
        return view('products.createorupdate', compact('categories', 'user'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductRequest $request)
    {

        if ($request->has('image_link')) {
            $file = $request->image_link;
            $ext = $request->image_link->extension();
            $file_name = time() . '-' . 'product.' . $ext;
            $file->move(public_path('uploads'), $file_name);
        }
        $new_product = $this->product->updateOrCreate(
            ['id' => $request->id ?? 'null'],
            [
                'name' => $request->name,
                'price' => $request->price,
                'discount' => $request->discount,
                'create' => $request->create,
                'user_shop_id' => $request->user_shop_id,
                'category_id' => $request->category_id,
                'image' => $file_name
            ]
        );


        if ($request->hasFile('small_images')) {
            $this->image->smallImage($request->small_images, $new_product);
        }

        return redirect()->route('products.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        $smallimage = $this->image->whereImage($product->id)->get();
        $categories = $this->category->all();
        $product = $this->product->find($product->id);
        $user = auth()->user()->id;
        $this->authorize('view', $product);
        return view('products.createorupdate', compact('categories', 'product', 'user', 'smallimage'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(ProductRequest $request, Product $product)
    {
        if ($request->hasfile('image_link')) {
            $file = $request->image_link;
            $ext = $request->image_link->extension();
            $file_name = time() . '-' . 'product.' . $ext;
            $file->move(public_path('uploads'), $file_name);
            unlink(public_path('uploads/' . $product->image));
            $request->merge(['image' => $file_name]);
            $this->product->updateOrCreate(
                ['id' => $product->id],
                [
                    'image' => $request->image,
                    'name' => $request->name,
                    'price' => $request->price,
                    'discount' => $request->discount,
                    'create' => $request->create,
                    'user_shop_id' => $request->user_shop_id,
                    'category_id' => $request->category_id,

                ]
            );
        } else {
            $this->product->updateOrCreate(
                ['id' => $product->id],
                [
                    'name' => $request->name,
                    'price' => $request->price,
                    'discount' => $request->discount,
                    'create' => $request->create,
                    'user_shop_id' => $request->user_shop_id,
                    'category_id' => $request->category_id,
                    'image' => $product->image
                ]
            );
        }


        if ($request->hasfile('small_images')) {

            $smallimages = $this->image->whereImage($product->id)->get();
            $this->image->updateImage($smallimages, $request->small_images, $product);
        }

        return redirect()->route('products.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $this->product->find($product->id)->delete();
        return redirect()->route('products.index');
    }
    public function listSoftDelete()
    {

        $products = $this->product->with('category')->onlyTrashed()->get();
        return view('products.list_softdelete')->with('products', $products);
    }
    public function restore($id)
    {

        $product = $this->product->onlyTrashed()->where('id', $id)->first();

        $this->authorize('restore', $product);
        $product->restore();
        return redirect()->route('products.index');
    }
    public function realDelete($id)
    {
        $product = $this->product->onlyTrashed()->where('id', $id)->first();
        $images = $this->image->whereImage($id)->get();

        $this->authorize('forceDelete', $product);
        $this->image->deleteImage($images);
        unlink(public_path('uploads/' . $product->image));
        $this->image->whereImage($id)->delete();
        $product->forceDelete();
        return redirect()->back();
    }
    public function updateDiscount(Request $request){
        // dd($request->all());
        foreach($request->discounts as $discount){
            $this->product->updateOrCreate(
                ['id'=>$discount],
                ['discount'=>$request->slcdiscount]
            );
        }
        // for($i=0;$i<count($request->discounts);$i++){
        //    $this->product->find($request->discounts[$i])->update([
        //         'discount'=>$request->discount,
        //     ]);
        // }
        return response()->json(200);
    }
}

resources/views/products/createorupdate.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body" style="color: black">
        <div class="card-header">
            <h3 style="color: blue" class="card-title">Create product</h3>
        </div>
        <div class="card">

            <div class="card-body">
                <form
                    action=" @if (isset($product->id)) {{ route('products.update', $product->id) }}
                @else
                    {{ route('products.store') }} @endif "
                    method="POST" enctype="multipart/form-data">
                    @csrf
                    @if (isset($product->id))
                        @method('PUT')
                    @endif
                    @include('components.input_sample', [
                        'name' => 'name',
                        'value' => $product->name ?? '',
                    ])
                    @include('components.input_sample', [
                        'name' => 'price',
                        'type' => 'number',
                        'value' => $product->price ?? '',
                    ])
                    @include('components.input_sample', [
                        'name' => 'discount',
                        'type' => 'number',
                        'value' => $product->discount ?? '',
                    ])
                    @include('components.input_sample', [
                        'name' => 'create',
                        'type' => 'date',
                        'date'=>\Carbon\Carbon::now()->toDateString(),
                        'value' => $product->create ?? '',
                    ])
                    @include('components.input_image', [
                        'value' => $product->image ?? '',
                    ])

                    @include('components.input', [
                        'name' => 'user_shop_id',
                        'type' => 'hidden',
                        'value' => $user,
                    ])
                    @if (isset($smallimage))
                   
                    @for ($i = 0; $i < count($smallimage); $i++)
                        @include('components.input_image', [
                        'id_div_image' => 'smallimages',
                        'imagename' => 'image small',
                        'name' => 'small_images[]',
                        'value' => $smallimage[$i]->image_link ?? '',
                        'image_small' => 'small_images',
                    ])
                    @endfor
                        
                    @else
                    <button type="button" id="add_btn" class="ml-5 btn btn-primary">Submit</button>
                        @include('components.input_image', [
                        'id_div_image' => 'smallimages',
                        'imagename' => 'image small',
                        'name' => 'small_images[]',
                        'value' => $smallimage ?? '',
                        'image_small' => 'small_images',
                    ])
                    @endif
                    
                    <div class="mb-3"style="color: black">
                        <select class="form-control" name="category_id" id="">
                            @foreach ($categories as $category)
                                <option
                                    @if (isset($product->category_id)) @selected($category->id=$product->category_id) @endif
                                    value="{{ $category->id }}">{{ $category->name }}</option>
                            @endforeach
                        </select>
                    </div>

                    <button type="submit" class="ml-5 btn btn-primary">Submit</button>
                </form>
            </div>

            <div class="card-footer clearfix">

            </div>
        </div>
    </div>
@endsection
@section('js')
    <script src="https://code.jquery.com/jquery-3.6.1.slim.min.js"
        integrity="sha256-w8CvhFs7iHNVUtnSP0YKEg00p9Ih13rlL9zGqvLdePA=" crossorigin="anonymous"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#add_btn').on('click', function() {
                var html = '';
                html += '<div class="mb-3" id="smallimage">';
                html += ' <div class="mb-4" style="color: black; display: flex">';
                html += '<label for="exampleInputEmail1">image small</label>';
                html += '<input type="file" multiple class="form-control" name="small_images[]"';
                html += '</div>';
                html += '<button type="button" id="remove" class="btn btn-danger">Xoa</button>';
                html += '</div>';
                html +='  @error('small_image')';
                html +=' <div class="alert alert-danger">{{ $message }}</div>';
                html +='@enderror';
           
        
                $('#smallimages').append(html);
            })
        })
        $(document).on('click','#remove',function(){
            $(this).parent().remove();
        })
    </script>
@endsection

resources/views/products/index.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Danh sách sản phẩm</h3>
        </div>
        <div class="card">
            <div class="card-body">
                <div class="p-2 bd-highlight">
                    <form data-url="{{ route('product.updateDiscount') }}">
                        <select name="slcdiscount" id="slcdiscount">
                            <option value="">------Chọn-----</option>
                            <option value="10">10%</option>
                            <option value="20">20%</option>
                            <option value="30">30%</option>
                            <option value="40">40%</option>
                            <option value="50">50%</option>
                        </select>
                        <button type="submit" id="apply" class="btn btn-primary">apply</button>
                    </form>
                    <a href="{{ route('products.create') }}" class="btn btn-success">Add</a>
                    <a class="btn btn-secondary" href="{{ route('product.softDelete') }}">Restore</a>
                </div>

                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th><input class="checkall" type="checkbox"></th>
                            <th>STT</th>
                            <th>Name</th>
                            <th>Price</th>
                            <th>Discount</th>
                            <th>Category</th>
                            <th>Image</th>
                            <th>Create</th>
                            <th style="width:20px;">Edit</th>
                            <th style="width:20px;">Delete</th>
                        </tr>

                        @foreach ($products as $product)
                            <tr>
                                <td><input type="checkbox" class="check_chidren" id="discounts" value="{{ $product->id }}" name="discounts"></td>
                                <td>{{ $i++ }}</td>
                                <td>{{ $product->name }}</td>
                                <td>{{ $product->price }}</td>
                                <td>{{ $product->discount }}</td>
                                <td>{{ $product->category->name }}</td>
                                <td><img style="height: 50px;width: 50px;" src="/uploads/{{ $product->image }}"></td>
                                <td>{{ $product->create }}</td>
                                <td style="width:20px;"><a class="btn btn-primary"
                                        href="{{ route('products.edit', $product->id) }}">Edit</a></td>
                                <td style="width:20px;">
                                    <form action="{{ route('products.destroy', $product->id) }}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-danger">Delete</button>
                                    </form>
                                </td>
                            </tr>
                        @endforeach

                    <tbody>



                </table>
            </div>
        </div>
    </div>
@endsection
@section('js')
    <script src="https://code.jquery.com/jquery-3.6.1.min.js"
        integrity="sha256-o88AwQnZB+VDvE9tvIXrMQaPlFFSUTR+nldQm1LuPXQ=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
        integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous">
    </script>
    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
   
    <script>
        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="_token"]').attr('content')
            }
        });
        $(document).ready(function() {
            $("#apply").on('click', function(e) {
                e.preventDefault();
                // alert(1312);
                const discounts = [];
                $('input[name^="discounts"]').each(function() {
                    if ($(this).is(":checked")) {
                        discounts.push($(this).val());
                    }
                    console.log(discounts);
                });
                var url = $(this).attr('data-url');
                var data = {
                    _token: '{!! csrf_token() !!}',
                    'slcdiscount': $('#slcdiscount').val(),
                    'discounts': discounts,

                };
                console.log(data);
                $.ajax({
                    type: 'post',
                    url: 'product-discount',
                    data: data,
                }).done(function(response) {
                    swal({
                        title: "Good job!",
                        text: "Click Continue",
                        icon: "success",
                        button: "Oke",
                    });
                    window.location.reload();
                }).fail(function(response) {
                    swal({
                        title: "You have not selected discount or product",
                        text: "Click Continue",
                        icon: "error",
                        button: "Oke",
                    });
                });


            })
        })
        $('.checkall').on('click',function(){
            $(this).parents().find('.check_chidren').prop('checked',$(this).prop('checked'));
        })

    </script>
@endsection

resources/views/products/list_softdelete.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Danh sách sản phẩm</h3>
        </div>
        <div class="card">
            <div class="card-body">
              
                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th>STT</th>
                            <th>Name</th>
                            <th>Price</th>
                            <th>Discount</th>
                            <th>Category</th>
                            <th>Image</th>
                            <th>Create</th>
                            <th style="width:20px;">Restore</th>
                            <th style="width:20px;">Delete</th>
                        </tr>
           
                    @foreach ($products as $product)
                        <tr>
                            <td>{{ $i++ }}</td>
                            <td>{{ $product->name }}</td>
                            <td>{{ $product->price }}</td>
                            <td>{{ $product->discount }}</td>
                            <td>{{ $product->category->name }}</td>
                            <td><img style="height: 50px;width: 50px;" src="/uploads/{{$product->image}}"></td>
                            <td>{{ $product->create }}</td>
                            <td style="width:20px;"><a class="btn btn-primary"
                                    href="{{ route('product.restore', $product->id) }}">Restore</a></td>
                            <td style="width:20px;">
                                <form action="{{ route('product.realDelete', $product->id) }}" method="POST">
                                    @csrf
                                    @method('DELETE')
                                    <button type="submit" class="btn btn-danger">Delete</button>
                                </form>
                            </td>
                        </tr>
                    @endforeach

                    <tbody>



                </table>
            </div>
        </div>
    </div>
@endsection
@section('js')
@endsection

resources/views/products/order.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Danh sách sản phẩm</h3>
        </div>
        <div class="card">
            <div class="card-body">
                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th>STT</th>
                            <th>Name</th>
                            <th>Price</th>
                            <th style="width:20px;">Tình trạng</th>
                            <th>Amount</th>
                            <th>Address</th>
                            <th style="width:20px;">Tổng tiền</th>
                            <th style="width:20px;">Ngày</th>
                        </tr>

                        @foreach ($orders as $order)
                            @if (isset($order->product->user_shop_id) && $order->product->user_shop_id == auth()->user()->id)
                                <tr>
                                    <td>{{ $i++ }}</td>
                                    <td>{{ $order->name }}</td>
                                    <td>{{ $order->price }}</td>
                                    <td>
                                        @if ($order->status == status_on)
                                            <form action="{{ route('order.update', $order->id) }}" method="POST">
                                                @csrf
                                                @method('PUT')

                                                <button class="btn btn-success" type="submit"> Xác nhận </button>
                                            </form>
                                        @else
                                            {{ 'Đã thanh toán' }}
                                        @endif

                                    </td>
                                    <td>{{ $order->soluong }}</td>
                                    <td>{{ $order->transaction->address }}</td>
                                    <td>{{ $order->transaction->total }}</td>
                                    <td>{{ $order->transaction->created_at }}</td>
                                    </td>
                                </tr>
                            @endif
                        @endforeach
                    <tbody>
                </table>
            </div>
        </div>
    </div>
@endsection
@section('js') 
@endsection